;******************************************************************************
;* TMS320C6x C/C++ Codegen                                    PC Version 4.36 *
;* Date/Time created: Tue May 17 23:14:56 2005                                *
;******************************************************************************

;******************************************************************************
;* GLOBAL FILE PARAMETERS                                                     *
;*                                                                            *
;*   Architecture      : TMS320C670x                                          *
;*   Optimization      : Enabled at level 3                                   *
;*   Optimizing for    : Speed                                                *
;*                       Based on options: -o3, no -ms                        *
;*   Endian            : Little                                               *
;*   Interrupt Thrshld : Infinite                                             *
;*   Memory Model      : Small                                                *
;*   Calls to RTS      : Near                                                 *
;*   Pipelining        : Enabled                                              *
;*   Speculative Load  : Enabled                                              *
;*   Memory Aliases    : Presume not aliases (optimistic)                     *
;*   Debug Info        : No Debug Info                                        *
;*                                                                            *
;******************************************************************************

	.asg	A15, FP
	.asg	B14, DP
	.asg	B15, SP
	.global	$bss


	.sect	".cinit"
	.align	8
	.field  	IR_1,32
	.field  	_a+0,32
	.word	03f800000h		; _a[0] @ 0
	.word	040000000h		; _a[1] @ 32
	.word	040400000h		; _a[2] @ 64
	.word	040800000h		; _a[3] @ 96
	.word	040a00000h		; _a[4] @ 128
	.word	03f800000h		; _a[5] @ 160
	.word	040000000h		; _a[6] @ 192
	.word	040400000h		; _a[7] @ 224
	.word	040800000h		; _a[8] @ 256
	.word	040a00000h		; _a[9] @ 288
	.word	03f800000h		; _a[10] @ 320
	.word	040000000h		; _a[11] @ 352
	.word	040400000h		; _a[12] @ 384
	.word	040800000h		; _a[13] @ 416
	.word	040a00000h		; _a[14] @ 448
	.word	03f800000h		; _a[15] @ 480
	.word	040000000h		; _a[16] @ 512
	.word	040400000h		; _a[17] @ 544
	.word	040800000h		; _a[18] @ 576
	.word	040a00000h		; _a[19] @ 608
IR_1:	.set	80

	.sect	".text"
	.global	_a
	.bss	_a,80,8

	.sect	".cinit"
	.align	8
	.field  	IR_2,32
	.field  	_b+0,32
	.word	03f800000h		; _b[0] @ 0
	.word	040000000h		; _b[1] @ 32
	.word	040400000h		; _b[2] @ 64
	.word	040800000h		; _b[3] @ 96
	.word	040a00000h		; _b[4] @ 128
	.word	03f800000h		; _b[5] @ 160
	.word	040000000h		; _b[6] @ 192
	.word	040400000h		; _b[7] @ 224
	.word	040800000h		; _b[8] @ 256
	.word	040a00000h		; _b[9] @ 288
	.word	03f800000h		; _b[10] @ 320
	.word	040000000h		; _b[11] @ 352
	.word	040400000h		; _b[12] @ 384
	.word	040800000h		; _b[13] @ 416
	.word	040a00000h		; _b[14] @ 448
	.word	03f800000h		; _b[15] @ 480
	.word	040000000h		; _b[16] @ 512
	.word	040400000h		; _b[17] @ 544
	.word	040800000h		; _b[18] @ 576
	.word	040a00000h		; _b[19] @ 608
IR_2:	.set	80

	.sect	".text"
	.global	_b
	.bss	_b,80,8

	.sect	".cinit"
	.align	8
	.field  	IR_3,32
	.field  	_input1$0+0,32
	.word	03f800000h		; _input1$0[0]._real @ 0
	.word	040000000h		; _input1$0[0]._imaginary @ 32
	.word	03f800000h		; _input1$0[1]._real @ 64
	.word	040000000h		; _input1$0[1]._imaginary @ 96
	.word	03f800000h		; _input1$0[2]._real @ 128
	.word	040000000h		; _input1$0[2]._imaginary @ 160
	.word	03f800000h		; _input1$0[3]._real @ 192
	.word	040000000h		; _input1$0[3]._imaginary @ 224
	.word	03f800000h		; _input1$0[4]._real @ 256
	.word	040000000h		; _input1$0[4]._imaginary @ 288
	.word	03f800000h		; _input1$0[5]._real @ 320
	.word	040000000h		; _input1$0[5]._imaginary @ 352
	.word	03f800000h		; _input1$0[6]._real @ 384
	.word	040000000h		; _input1$0[6]._imaginary @ 416
	.word	03f800000h		; _input1$0[7]._real @ 448
	.word	040000000h		; _input1$0[7]._imaginary @ 480
	.word	03f800000h		; _input1$0[8]._real @ 512
	.word	040000000h		; _input1$0[8]._imaginary @ 544
	.word	03f800000h		; _input1$0[9]._real @ 576
	.word	040000000h		; _input1$0[9]._imaginary @ 608
	.word	03f800000h		; _input1$0[10]._real @ 640
	.word	040000000h		; _input1$0[10]._imaginary @ 672
	.word	03f800000h		; _input1$0[11]._real @ 704
	.word	040000000h		; _input1$0[11]._imaginary @ 736
	.word	03f800000h		; _input1$0[12]._real @ 768
	.word	040000000h		; _input1$0[12]._imaginary @ 800
	.word	03f800000h		; _input1$0[13]._real @ 832
	.word	040000000h		; _input1$0[13]._imaginary @ 864
	.word	03f800000h		; _input1$0[14]._real @ 896
	.word	040000000h		; _input1$0[14]._imaginary @ 928
	.word	03f800000h		; _input1$0[15]._real @ 960
	.word	040000000h		; _input1$0[15]._imaginary @ 992
	.word	03f800000h		; _input1$0[16]._real @ 1024
	.word	040000000h		; _input1$0[16]._imaginary @ 1056
	.word	03f800000h		; _input1$0[17]._real @ 1088
	.word	040000000h		; _input1$0[17]._imaginary @ 1120
	.word	03f800000h		; _input1$0[18]._real @ 1152
	.word	040000000h		; _input1$0[18]._imaginary @ 1184
	.word	03f800000h		; _input1$0[19]._real @ 1216
	.word	040000000h		; _input1$0[19]._imaginary @ 1248
IR_3:	.set	160

	.sect	".text"
	.bss	_input1$0,160,8

	.sect	".cinit"
	.align	8
	.field  	IR_4,32
	.field  	_input2$0+0,32
	.word	03f800000h		; _input2$0[0]._real @ 0
	.word	040000000h		; _input2$0[0]._imaginary @ 32
	.word	03f800000h		; _input2$0[1]._real @ 64
	.word	040000000h		; _input2$0[1]._imaginary @ 96
	.word	03f800000h		; _input2$0[2]._real @ 128
	.word	040000000h		; _input2$0[2]._imaginary @ 160
	.word	03f800000h		; _input2$0[3]._real @ 192
	.word	040000000h		; _input2$0[3]._imaginary @ 224
	.word	03f800000h		; _input2$0[4]._real @ 256
	.word	040000000h		; _input2$0[4]._imaginary @ 288
	.word	03f800000h		; _input2$0[5]._real @ 320
	.word	040000000h		; _input2$0[5]._imaginary @ 352
	.word	03f800000h		; _input2$0[6]._real @ 384
	.word	040000000h		; _input2$0[6]._imaginary @ 416
	.word	03f800000h		; _input2$0[7]._real @ 448
	.word	040000000h		; _input2$0[7]._imaginary @ 480
	.word	03f800000h		; _input2$0[8]._real @ 512
	.word	040000000h		; _input2$0[8]._imaginary @ 544
	.word	03f800000h		; _input2$0[9]._real @ 576
	.word	040000000h		; _input2$0[9]._imaginary @ 608
	.word	03f800000h		; _input2$0[10]._real @ 640
	.word	040000000h		; _input2$0[10]._imaginary @ 672
	.word	03f800000h		; _input2$0[11]._real @ 704
	.word	040000000h		; _input2$0[11]._imaginary @ 736
	.word	03f800000h		; _input2$0[12]._real @ 768
	.word	040000000h		; _input2$0[12]._imaginary @ 800
	.word	03f800000h		; _input2$0[13]._real @ 832
	.word	040000000h		; _input2$0[13]._imaginary @ 864
	.word	03f800000h		; _input2$0[14]._real @ 896
	.word	040000000h		; _input2$0[14]._imaginary @ 928
	.word	03f800000h		; _input2$0[15]._real @ 960
	.word	040000000h		; _input2$0[15]._imaginary @ 992
	.word	03f800000h		; _input2$0[16]._real @ 1024
	.word	040000000h		; _input2$0[16]._imaginary @ 1056
	.word	03f800000h		; _input2$0[17]._real @ 1088
	.word	040000000h		; _input2$0[17]._imaginary @ 1120
	.word	03f800000h		; _input2$0[18]._real @ 1152
	.word	040000000h		; _input2$0[18]._imaginary @ 1184
	.word	03f800000h		; _input2$0[19]._real @ 1216
	.word	040000000h		; _input2$0[19]._imaginary @ 1248
IR_4:	.set	160

	.sect	".text"
	.bss	_input2$0,160,8

	.sect	".cinit"
	.align	8
	.field  	IR_5,32
	.field  	_RealInput1$0+0,32
	.word	03f800000h		; _RealInput1$0[0]._real @ 0
	.word	03f800000h		; _RealInput1$0[0]._imaginary @ 32
	.word	03f800000h		; _RealInput1$0[1]._real @ 64
	.word	03f800000h		; _RealInput1$0[1]._imaginary @ 96
	.word	03f800000h		; _RealInput1$0[2]._real @ 128
	.word	03f800000h		; _RealInput1$0[2]._imaginary @ 160
	.word	03f800000h		; _RealInput1$0[3]._real @ 192
	.word	03f800000h		; _RealInput1$0[3]._imaginary @ 224
	.word	03f800000h		; _RealInput1$0[4]._real @ 256
	.word	03f800000h		; _RealInput1$0[4]._imaginary @ 288
	.word	03f800000h		; _RealInput1$0[5]._real @ 320
	.word	03f800000h		; _RealInput1$0[5]._imaginary @ 352
	.word	03f800000h		; _RealInput1$0[6]._real @ 384
	.word	03f800000h		; _RealInput1$0[6]._imaginary @ 416
	.word	03f800000h		; _RealInput1$0[7]._real @ 448
	.word	03f800000h		; _RealInput1$0[7]._imaginary @ 480
	.word	03f800000h		; _RealInput1$0[8]._real @ 512
	.word	03f800000h		; _RealInput1$0[8]._imaginary @ 544
	.word	03f800000h		; _RealInput1$0[9]._real @ 576
	.word	03f800000h		; _RealInput1$0[9]._imaginary @ 608
IR_5:	.set	80

	.sect	".text"
	.bss	_RealInput1$0,160,8

	.sect	".cinit"
	.align	8
	.field  	IR_6,32
	.field  	_ImagInput1$0+0,32
	.word	040000000h		; _ImagInput1$0[0]._real @ 0
	.word	040000000h		; _ImagInput1$0[0]._imaginary @ 32
	.word	040000000h		; _ImagInput1$0[1]._real @ 64
	.word	040000000h		; _ImagInput1$0[1]._imaginary @ 96
	.word	040000000h		; _ImagInput1$0[2]._real @ 128
	.word	040000000h		; _ImagInput1$0[2]._imaginary @ 160
	.word	040000000h		; _ImagInput1$0[3]._real @ 192
	.word	040000000h		; _ImagInput1$0[3]._imaginary @ 224
	.word	040000000h		; _ImagInput1$0[4]._real @ 256
	.word	040000000h		; _ImagInput1$0[4]._imaginary @ 288
	.word	040000000h		; _ImagInput1$0[5]._real @ 320
	.word	040000000h		; _ImagInput1$0[5]._imaginary @ 352
	.word	040000000h		; _ImagInput1$0[6]._real @ 384
	.word	040000000h		; _ImagInput1$0[6]._imaginary @ 416
	.word	040000000h		; _ImagInput1$0[7]._real @ 448
	.word	040000000h		; _ImagInput1$0[7]._imaginary @ 480
	.word	040000000h		; _ImagInput1$0[8]._real @ 512
	.word	040000000h		; _ImagInput1$0[8]._imaginary @ 544
	.word	040000000h		; _ImagInput1$0[9]._real @ 576
	.word	040000000h		; _ImagInput1$0[9]._imaginary @ 608
IR_6:	.set	80

	.sect	".text"
	.bss	_ImagInput1$0,160,8

	.sect	".cinit"
	.align	8
	.field  	IR_7,32
	.field  	_RealInput2$0+0,32
	.word	03f800000h		; _RealInput2$0[0]._real @ 0
	.word	03f800000h		; _RealInput2$0[0]._imaginary @ 32
	.word	03f800000h		; _RealInput2$0[1]._real @ 64
	.word	03f800000h		; _RealInput2$0[1]._imaginary @ 96
	.word	03f800000h		; _RealInput2$0[2]._real @ 128
	.word	03f800000h		; _RealInput2$0[2]._imaginary @ 160
	.word	03f800000h		; _RealInput2$0[3]._real @ 192
	.word	03f800000h		; _RealInput2$0[3]._imaginary @ 224
	.word	03f800000h		; _RealInput2$0[4]._real @ 256
	.word	03f800000h		; _RealInput2$0[4]._imaginary @ 288
	.word	03f800000h		; _RealInput2$0[5]._real @ 320
	.word	03f800000h		; _RealInput2$0[5]._imaginary @ 352
	.word	03f800000h		; _RealInput2$0[6]._real @ 384
	.word	03f800000h		; _RealInput2$0[6]._imaginary @ 416
	.word	03f800000h		; _RealInput2$0[7]._real @ 448
	.word	03f800000h		; _RealInput2$0[7]._imaginary @ 480
	.word	03f800000h		; _RealInput2$0[8]._real @ 512
	.word	03f800000h		; _RealInput2$0[8]._imaginary @ 544
	.word	03f800000h		; _RealInput2$0[9]._real @ 576
	.word	03f800000h		; _RealInput2$0[9]._imaginary @ 608
IR_7:	.set	80

	.sect	".text"
	.bss	_RealInput2$0,160,8

	.sect	".cinit"
	.align	8
	.field  	IR_8,32
	.field  	_ImagInput2$0+0,32
	.word	040000000h		; _ImagInput2$0[0]._real @ 0
	.word	040000000h		; _ImagInput2$0[0]._imaginary @ 32
	.word	040000000h		; _ImagInput2$0[1]._real @ 64
	.word	040000000h		; _ImagInput2$0[1]._imaginary @ 96
	.word	040000000h		; _ImagInput2$0[2]._real @ 128
	.word	040000000h		; _ImagInput2$0[2]._imaginary @ 160
	.word	040000000h		; _ImagInput2$0[3]._real @ 192
	.word	040000000h		; _ImagInput2$0[3]._imaginary @ 224
	.word	040000000h		; _ImagInput2$0[4]._real @ 256
	.word	040000000h		; _ImagInput2$0[4]._imaginary @ 288
	.word	040000000h		; _ImagInput2$0[5]._real @ 320
	.word	040000000h		; _ImagInput2$0[5]._imaginary @ 352
	.word	040000000h		; _ImagInput2$0[6]._real @ 384
	.word	040000000h		; _ImagInput2$0[6]._imaginary @ 416
	.word	040000000h		; _ImagInput2$0[7]._real @ 448
	.word	040000000h		; _ImagInput2$0[7]._imaginary @ 480
	.word	040000000h		; _ImagInput2$0[8]._real @ 512
	.word	040000000h		; _ImagInput2$0[8]._imaginary @ 544
	.word	040000000h		; _ImagInput2$0[9]._real @ 576
	.word	040000000h		; _ImagInput2$0[9]._imaginary @ 608
IR_8:	.set	80

	.sect	".text"
	.bss	_ImagInput2$0,160,8

	.sect	".cinit"
	.align	8
	.field  	IR_9,32
	.field  	_IIRCoeffArray+0,32
	.word	03f800000h		; _IIRCoeffArray[0] @ 0
	.word	040000000h		; _IIRCoeffArray[1] @ 32
	.word	040400000h		; _IIRCoeffArray[2] @ 64
	.word	040800000h		; _IIRCoeffArray[3] @ 96
	.word	040a00000h		; _IIRCoeffArray[4] @ 128
	.word	040c00000h		; _IIRCoeffArray[5] @ 160
	.word	040e00000h		; _IIRCoeffArray[6] @ 192
	.word	041000000h		; _IIRCoeffArray[7] @ 224
	.word	041100000h		; _IIRCoeffArray[8] @ 256
	.word	041200000h		; _IIRCoeffArray[9] @ 288
	.word	041300000h		; _IIRCoeffArray[10] @ 320
	.word	041400000h		; _IIRCoeffArray[11] @ 352
	.word	041500000h		; _IIRCoeffArray[12] @ 384
	.word	041600000h		; _IIRCoeffArray[13] @ 416
	.word	041700000h		; _IIRCoeffArray[14] @ 448
	.word	041800000h		; _IIRCoeffArray[15] @ 480
	.word	041880000h		; _IIRCoeffArray[16] @ 512
	.word	041900000h		; _IIRCoeffArray[17] @ 544
	.word	041980000h		; _IIRCoeffArray[18] @ 576
	.word	041a00000h		; _IIRCoeffArray[19] @ 608
	.word	041a80000h		; _IIRCoeffArray[20] @ 640
	.word	041b00000h		; _IIRCoeffArray[21] @ 672
	.word	041b80000h		; _IIRCoeffArray[22] @ 704
	.word	041c00000h		; _IIRCoeffArray[23] @ 736
	.word	041c80000h		; _IIRCoeffArray[24] @ 768
	.word	041d00000h		; _IIRCoeffArray[25] @ 800
	.word	041d80000h		; _IIRCoeffArray[26] @ 832
	.word	041e00000h		; _IIRCoeffArray[27] @ 864
	.word	041e80000h		; _IIRCoeffArray[28] @ 896
	.word	041f00000h		; _IIRCoeffArray[29] @ 928
	.word	041f80000h		; _IIRCoeffArray[30] @ 960
	.word	042000000h		; _IIRCoeffArray[31] @ 992
	.word	042040000h		; _IIRCoeffArray[32] @ 1024
	.word	042080000h		; _IIRCoeffArray[33] @ 1056
	.word	0420c0000h		; _IIRCoeffArray[34] @ 1088
	.word	042100000h		; _IIRCoeffArray[35] @ 1120
	.word	042140000h		; _IIRCoeffArray[36] @ 1152
	.word	042180000h		; _IIRCoeffArray[37] @ 1184
	.word	0421c0000h		; _IIRCoeffArray[38] @ 1216
	.word	042200000h		; _IIRCoeffArray[39] @ 1248
IR_9:	.set	160

	.sect	".text"
	.global	_IIRCoeffArray
	.bss	_IIRCoeffArray,160,8
	.global	_IIRStatePtr
	.bss	_IIRStatePtr,80,4
;	opt6x -p2 -t -i0 -n2 -v6700 -q -O3 C:\DOCUME~1\ADMINI~1\LOCALS~1\Temp\TI2972_5 C:\DOCUME~1\ADMINI~1\LOCALS~1\Temp\TI2972_6 
;**	Parameter deleted: length == 32;
;**	Parameter deleted: b == &b;
;**	Parameter deleted: a == &a;

	.sect	".text"
	.global	_DotP

;******************************************************************************
;* FUNCTION NAME: _DotP                                                       *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,B0,B1,B4,B5,B6,B7,B8,B9         *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,B0,B1,B3,B4,B5,B6,B7,B8,B9,DP   *
;*   Local Frame Size  : 0 Args + 0 Auto + 0 Save = 0 byte                    *
;******************************************************************************
_DotP:
;** --------------------------------------------------------------------------*

           MVK     .S2     (_b-$bss),B4
||         MVK     .S1     (_a-$bss),A0

           ADD     .D2     DP,B4,B7
||         ADD     .S1X    DP,A0,A3

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 286
;*      Loop opening brace source line   : 287
;*      Loop closing brace source line   : 289
;*      Loop Unroll Multiple             : 4x
;*      Known Minimum Trip Count         : 8
;*      Known Maximum Trip Count         : 8
;*      Known Max Trip Count Factor      : 8
;*      Loop Carried Dependency Bound(^) : 4
;*      Unpartitioned Resource Bound     : 2
;*      Partitioned Resource Bound(*)    : 2
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     2*       2*    
;*      .S units                     1        0     
;*      .D units                     2*       2*    
;*      .M units                     2*       2*    
;*      .X cross paths               2*       2*    
;*      .T address paths             2*       2*    
;*      Long read paths              0        0     
;*      Long write paths             2*       2*    
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          0        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             2*       1     
;*      Bound(.L .S .D .LS .LSD)     2*       2*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 4  Schedule found with 4 iterations in parallel
;*
;*      Register Usage Table:
;*          +---------------------------------+
;*          |AAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBB|
;*          |0000000000111111|0000000000111111|
;*          |0123456789012345|0123456789012345|
;*          |----------------+----------------|
;*       0: |******          |**  *****       |
;*       1: |  **            |**     *        |
;*       2: |  **            |**     *        |
;*       3: |***** *         |**  ** ***      |
;*          +---------------------------------+
;*
;*      Done
;*
;*      Epilog not entirely removed
;*      Collapsed epilog stages     : 2
;*
;*      Prolog not entirely removed
;*      Collapsed prolog stages     : 2
;*
;*      Minimum required memory pad : 32 bytes
;*
;*      Minimum safe trip count     : 1 (after unrolling)
;*----------------------------------------------------------------------------*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C23:
;*   0              LDDW    .D2T2   *B7++(16),B5:B4   ; |288| 
;*       ||         LDDW    .D1T1   *A3++(16),A1:A0   ; |288| 
;*   1              LDDW    .D2T2   *-B7(8),B5:B4     ; |288| 
;*       ||         LDDW    .D1T1   *-A3(8),A1:A0     ; |288| 
;*   2              NOP             3
;*   5              MPYSP   .M2X    B4,A0,B9          ; |288| 
;*       ||         MPYSP   .M1X    B5,A1,A6          ; |288| 
;*   6              MPYSP   .M2X    B4,A0,B8          ; |288| 
;*       ||         MPYSP   .M1X    B5,A1,A4          ; |288| 
;*   7      [ B0]   SUB     .D2     B0,1,B0           ; |289| 
;*   8      [ B0]   B       .S1     C23               ; |289| 
;*   9              ADDSP   .L2     B9,B8,B8          ; |288|  ^ 
;*       ||         ADDSP   .L1     A6,A4,A4          ; |288|  ^ 
;*  10              ADDSP   .L2     B8,B6,B6          ; |288|  ^ 
;*       ||         ADDSP   .L1     A4,A5,A5          ; |288|  ^ 
;*  11              NOP             3
;*                  ; BRANCH OCCURS                   ; |289| 
;*----------------------------------------------------------------------------*
L1:    ; PIPED LOOP PROLOG

           ZERO    .L2     B8                ; |286| 
||         ZERO    .L1     A4                ; |286| 
||         MVK     .S2     0x1,B1            ; init prolog collapse predicate
||         LDDW    .D2T2   *B7++(16),B5:B4   ; |288| (P) <0,0> 
||         B       .S1     L2                ; |289| (P) <0,8> 
||         LDDW    .D1T1   *A3++(16),A1:A0   ; |288| (P) <0,0> 

           ZERO    .L2     B6                ; |286| 
||         ZERO    .L1     A5                ; |286| 
||         MVK     .S1     0x2,A2            ; init prolog collapse predicate
||         MVK     .S2     0x8,B0            ; |286| 
||         LDDW    .D2T2   *-B7(8),B5:B4     ; |288| (P) <0,1> 
||         LDDW    .D1T1   *-A3(8),A1:A0     ; |288| (P) <0,1> 

;** --------------------------------------------------------------------------*
L2:    ; PIPED LOOP KERNEL

   [!A2]   ADDSP   .L2     B8,B6,B6          ; |288| <0,10>  ^ 
|| [!A2]   ADDSP   .L1     A4,A5,A5          ; |288| <0,10>  ^ 
|| [!B1]   MPYSP   .M2X    B4,A0,B8          ; |288| <1,6> 
|| [!B1]   MPYSP   .M1X    B5,A1,A4          ; |288| <1,6> 

   [ B0]   SUB     .D2     B0,1,B0           ; |289| <1,7> 

   [ B0]   B       .S1     L2                ; |289| <1,8> 
||         LDDW    .D2T2   *B7++(16),B5:B4   ; |288| <3,0> 
||         LDDW    .D1T1   *A3++(16),A1:A0   ; |288| <3,0> 

   [ B1]   SUB     .S2     B1,1,B1           ; <0,13> 
|| [ A2]   SUB     .S1     A2,1,A2           ; <0,13> 
|| [!B1]   ADDSP   .L2     B9,B8,B8          ; |288| <1,9>  ^ 
|| [!B1]   ADDSP   .L1     A6,A4,A4          ; |288| <1,9>  ^ 
||         MPYSP   .M2X    B4,A0,B9          ; |288| <2,5> 
||         MPYSP   .M1X    B5,A1,A6          ; |288| <2,5> 
||         LDDW    .D2T2   *-B7(8),B5:B4     ; |288| <3,1> 
||         LDDW    .D1T1   *-A3(8),A1:A0     ; |288| <3,1> 

;** --------------------------------------------------------------------------*
L3:    ; PIPED LOOP EPILOG

           ADDSP   .L1     A4,A5,A5          ; |288| (E) <3,10>  ^ 
||         ADDSP   .L2     B8,B6,B6          ; |288| (E) <3,10>  ^ 

           NOP             3
           ADDSP   .L1X    B6,A5,A0          ; |291| 
           NOP             3
           ADDSP   .L1     A4,A0,A0          ; |291| 
           NOP             1
           RET     .S2     B3                ; |292| 
           NOP             1
           ADDSP   .L1X    B8,A0,A4          ; |291| 
           NOP             3
           ; BRANCH OCCURS                   ; |292| 


;**	Parameter deleted: count == 20;
;**	Parameter deleted: p_Input2 == (const struct $$fake0 *)&input2;
;**	Parameter deleted: p_Input1 == (const struct $$fake0 *)&input1;

	.sect	".text"
	.global	_ComplexDotP

;******************************************************************************
;* FUNCTION NAME: _ComplexDotP                                                *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,B0,B1,B2,B4,B5,B6,B7,B8,B9,SP   *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9,  *
;*                           DP,SP                                            *
;*   Local Frame Size  : 0 Args + 8 Auto + 0 Save = 8 byte                    *
;******************************************************************************
_ComplexDotP:
;** --------------------------------------------------------------------------*

           MVK     .S2     (_input2$0-$bss),B4
||         MVK     .S1     (_input1$0-$bss),A0

           ADD     .D2     DP,B4,B7
||         ADD     .S1X    DP,A0,A0

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 313
;*      Loop opening brace source line   : 314
;*      Loop closing brace source line   : 319
;*      Known Minimum Trip Count         : 20
;*      Known Maximum Trip Count         : 20
;*      Known Max Trip Count Factor      : 20
;*      Loop Carried Dependency Bound(^) : 4
;*      Unpartitioned Resource Bound     : 3
;*      Partitioned Resource Bound(*)    : 3
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     1        3*    
;*      .S units                     1        1     
;*      .D units                     2        2     
;*      .M units                     2        2     
;*      .X cross paths               3*       3*    
;*      .T address paths             2        2     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           1        0     (.L or .S unit)
;*      Addition ops (.LSD)          1        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             2        2     
;*      Bound(.L .S .D .LS .LSD)     2        3*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 4  Schedule found with 4 iterations in parallel
;*
;*      Register Usage Table:
;*          +---------------------------------+
;*          |AAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBB|
;*          |0000000000111111|0000000000111111|
;*          |0123456789012345|0123456789012345|
;*          |----------------+----------------|
;*       0: |*******         | *  *  **       |
;*       1: |****            |**    ***       |
;*       2: |**** **         |**   *****      |
;*       3: |**** *          | *   * **       |
;*          +---------------------------------+
;*
;*      Done
;*
;*      Epilog not entirely removed
;*      Collapsed epilog stages     : 2
;*
;*      Prolog not entirely removed
;*      Collapsed prolog stages     : 2
;*
;*      Minimum required memory pad : 16 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C74:
;*   0              LDW     .D2T2   *B7++(8),B0       ; |315| 
;*       ||         LDW     .D1T1   *A0++(8),A3       ; |315| 
;*   1              LDW     .D2T2   *-B7(4),B8        ; |315| 
;*       ||         LDW     .D1T1   *-A0(4),A6        ; |315| 
;*   2              NOP             3
;*   5              MPYSP   .M2X    B0,A3,B8          ; |315| 
;*   6              MPYSP   .M1X    B8,A6,A5          ; |315| 
;*       ||         MPYSP   .M2X    B0,A6,B9          ; |317| 
;*   7              NOP             1
;*   8              MPYSP   .M1X    B8,A3,A6          ; |317| 
;*   9              ADDSP   .L2     B8,B6,B6          ; |315|  ^ 
;*       ||         ZERO    .S2     B6                ; |315| 
;*       || [ A1]   SUB     .S1     A1,1,A1           ; |319| 
;*  10              SET     .S2     B6,31,31,B5       ; |315| 
;*       ||         ADDSP   .L2     B9,B5,B5          ; |317|  ^ 
;*       || [ A1]   B       .S1     C74               ; |319| 
;*  11              XOR     .S1X    A5,B5,A5          ; |315| 
;*  12              ADDSP   .L1     A5,A4,A4          ; |315|  ^ 
;*       ||         ADDSP   .L2X    A6,B4,B4          ; |317|  ^ 
;*  13              NOP             3
;*                  ; BRANCH OCCURS                   ; |319| 
;*----------------------------------------------------------------------------*
L4:    ; PIPED LOOP PROLOG

           LDW     .D1T1   *A0++(8),A3       ; |315| (P) <0,0> 
||         LDW     .D2T2   *B7++(8),B0       ; |315| (P) <0,0> 

           MVK     .S1     0x14,A1           ; |313| 
||         LDW     .D2T2   *-B7(4),B8        ; |315| (P) <0,1> 
||         LDW     .D1T1   *-A0(4),A6        ; |315| (P) <0,1> 

           ZERO    .D2     B5                ; |313| 
||         ZERO    .S2     B6                ; |313| 
||         SUB     .L2     SP,8,SP           ; |298| 
||         B       .S1     L5                ; |319| (P) <0,10> 

           ZERO    .D1     A4                ; |313| 
||         ZERO    .D2     B4                ; |313| 
||         MV      .L2X    A3,B2             ; |298| 
||         MVK     .S2     0x1,B1            ; init prolog collapse predicate
||         MVK     .S1     0x2,A2            ; init prolog collapse predicate

;** --------------------------------------------------------------------------*
L5:    ; PIPED LOOP KERNEL

   [!A2]   ADDSP   .L2X    A6,B4,B4          ; |317| <0,12>  ^ 
|| [!A2]   ADDSP   .L1     A5,A4,A4          ; |315| <0,12>  ^ 
||         MPYSP   .M1X    B8,A3,A6          ; |317| <1,8> 
||         LDW     .D2T2   *B7++(8),B0       ; |315| <3,0> 
||         LDW     .D1T1   *A0++(8),A3       ; |315| <3,0> 

   [!B1]   ZERO    .S2     B6                ; |315| <1,9> 
|| [ A1]   SUB     .S1     A1,1,A1           ; |319| <1,9> 
|| [!B1]   ADDSP   .L2     B8,B6,B6          ; |315| <1,9>  ^ 
||         MPYSP   .M2X    B0,A3,B8          ; |315| <2,5> 
||         LDW     .D2T2   *-B7(4),B8        ; |315| <3,1> 
||         LDW     .D1T1   *-A0(4),A6        ; |315| <3,1> 

   [!B1]   SET     .S2     B6,31,31,B5       ; |315| <1,10> 
|| [!B1]   ADDSP   .L2     B9,B5,B5          ; |317| <1,10>  ^ 
|| [ A1]   B       .S1     L5                ; |319| <1,10> 
||         MPYSP   .M2X    B0,A6,B9          ; |317| <2,6> 
||         MPYSP   .M1X    B8,A6,A5          ; |315| <2,6> 

   [ B1]   SUB     .D2     B1,1,B1           ; <0,15> 
|| [ A2]   SUB     .D1     A2,1,A2           ; <0,15> 
||         XOR     .S1X    A5,B5,A5          ; |315| <1,11> 

;** --------------------------------------------------------------------------*
L6:    ; PIPED LOOP EPILOG

           ADD     .D2     4,SP,B4           ; |321| 
||         ADDSP   .L1     A5,A4,A4          ; |315| (E) <3,12>  ^ 
||         ADDSP   .L2X    A6,B4,B7          ; |317| (E) <3,12>  ^ 

           NOP             1
           MV      .S1X    B5,A3
           NOP             1

           ADDSP   .L2X    B6,A4,B6
||         ADDSP   .L1X    B7,A3,A0

           NOP             3
           STW     .D2T1   A0,*+SP(8)

           ADD     .S2     8,SP,SP           ; |322| 
||         STW     .D2T2   B6,*+SP(4)

   [ B2]   LDW     .D2T2   *B4,B4            ; |321| 

           RET     .S2     B3                ; |322| 
|| [ B2]   LDW     .D2T2   *+B4(4),B5        ; |321| 

           NOP             3
   [ B2]   STW     .D2T2   B4,*B2            ; |321| 
   [ B2]   STW     .D2T2   B5,*+B2(4)        ; |321| 
           ; BRANCH OCCURS                   ; |322| 


;**	Parameter deleted: count == 20;
;**	Parameter deleted: p_Input2 == &input2;
;**	Parameter deleted: p_Input1 == &input1;

	.sect	".text"
	.global	_ComplexDotP2

;******************************************************************************
;* FUNCTION NAME: _ComplexDotP2                                               *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,A7,A8,B0,B1,B4,B5,B6,B7,B8,B9,  *
;*                           SP                                               *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,A7,A8,B0,B1,B3,B4,B5,B6,B7,B8,  *
;*                           B9,DP,SP                                         *
;*   Local Frame Size  : 0 Args + 8 Auto + 0 Save = 8 byte                    *
;******************************************************************************
_ComplexDotP2:
;** --------------------------------------------------------------------------*
           MVK     .S1     (_input1$0-$bss),A0

           ZERO    .D2     B7                ; |344| 
||         MVK     .S1     0x14,A4           ; |344| 
||         MVK     .S2     (_input2$0-$bss),B4

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 344
;*      Loop opening brace source line   : 345
;*      Loop closing brace source line   : 350
;*      Known Minimum Trip Count         : 20
;*      Known Maximum Trip Count         : 20
;*      Known Max Trip Count Factor      : 20
;*      Loop Carried Dependency Bound(^) : 4
;*      Unpartitioned Resource Bound     : 2
;*      Partitioned Resource Bound(*)    : 3
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     2        2     
;*      .S units                     1        1     
;*      .D units                     1        1     
;*      .M units                     2        2     
;*      .X cross paths               3*       2     
;*      .T address paths             1        1     
;*      Long read paths              0        0     
;*      Long write paths             1        1     
;*      Logical  ops (.LS)           3        0     (.L or .S unit)
;*      Addition ops (.LSD)          1        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             3*       2     
;*      Bound(.L .S .D .LS .LSD)     3*       2     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 4  Schedule found with 5 iterations in parallel
;*
;*      Register Usage Table:
;*          +---------------------------------+
;*          |AAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBB|
;*          |0000000000111111|0000000000111111|
;*          |0123456789012345|0123456789012345|
;*          |----------------+----------------|
;*       0: |****   *        |*   ***         |
;*       1: |******* *       |*   *** **      |
;*       2: | *****          |*   *****       |
;*       3: |******          |*   * *         |
;*          +---------------------------------+
;*
;*      Done
;*
;*      Epilog not entirely removed
;*      Collapsed epilog stages     : 3
;*
;*      Prolog not entirely removed
;*      Collapsed prolog stages     : 3
;*
;*      Minimum required memory pad : 24 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C126:
;*   0              LDDW    .D2T2   *B6++,B5:B4       ; |348| 
;*   1              LDDW    .D1T1   *A3++,A5:A4       ; |348| 
;*   2              NOP             3
;*   5              MV      .S1X    B4,A0             ; |348| Define a twin register
;*   6              MPYSP   .M1     A0,A4,A8          ; |348| 
;*       ||         MPYSP   .M2X    B4,A5,B9          ; |349| 
;*   7              MV      .L1X    B5,A4             ; |348| Define a twin register
;*       ||         MPYSP   .M2X    B5,A4,B4          ; |349| 
;*   8              MPYSP   .M1     A4,A5,A0          ; |348| 
;*   9              NOP             1
;*  10              ADDSP   .L1     A8,A6,A6          ; |348|  ^ 
;*       ||         ZERO    .D2     B8                ; |348| 
;*       ||         ADDSP   .L2     B9,B8,B8          ; |349|  ^ 
;*       || [ A1]   SUB     .D1     A1,1,A1           ; |350| 
;*  11              SET     .S2     B8,31,31,B4       ; |348| 
;*       ||         ADDSP   .L2     B4,B7,B7          ; |349|  ^ 
;*       || [ A1]   B       .S1     C126              ; |350| 
;*  12              XOR     .S1X    A0,B4,A0          ; |348| 
;*  13              ADDSP   .L1     A0,A7,A7          ; |348|  ^ 
;*  14              NOP             3
;*                  ; BRANCH OCCURS                   ; |350| 
;*----------------------------------------------------------------------------*
L7:    ; PIPED LOOP PROLOG

           ZERO    .D1     A7                ; |344| 
||         ZERO    .D2     B8                ; |344| 
||         ZERO    .L1     A6                ; |344| 
||         SUB     .S2     SP,8,SP           ; |328| 
||         B       .S1     L8                ; |350| (P) <0,11> 
||         ADD     .L2     DP,B4,B6

           MV      .L2X    A3,B1             ; |328| 
||         MVK     .S2     0x2,B0            ; init prolog collapse predicate
||         MVK     .S1     0x3,A2            ; init prolog collapse predicate
||         ADD     .D1     1,A4,A1
||         ADD     .L1X    DP,A0,A3
||         LDDW    .D2T2   *B6++,B5:B4       ; |348| (P) <0,0> 

;** --------------------------------------------------------------------------*
L8:    ; PIPED LOOP KERNEL

   [!A2]   ADDSP   .L1     A0,A7,A7          ; |348| <0,13>  ^ 
||         MV      .S1X    B4,A0             ; |348| <2,5> Define a twin register
||         LDDW    .D1T1   *A3++,A5:A4       ; |348| <3,1> 

   [!B0]   ZERO    .D2     B8                ; |348| <1,10> 
|| [ A1]   SUB     .D1     A1,1,A1           ; |350| <1,10> 
|| [!B0]   ADDSP   .L1     A8,A6,A6          ; |348| <1,10>  ^ 
|| [!B0]   ADDSP   .L2     B9,B8,B8          ; |349| <1,10>  ^ 
||         MPYSP   .M2X    B4,A5,B9          ; |349| <2,6> 
||         MPYSP   .M1     A0,A4,A8          ; |348| <2,6> 

           SET     .S2     B8,31,31,B4       ; |348| <1,11> 
|| [ A1]   B       .S1     L8                ; |350| <1,11> 
|| [!B0]   ADDSP   .L2     B4,B7,B7          ; |349| <1,11>  ^ 
||         MV      .L1X    B5,A4             ; |348| <2,7> Define a twin register
||         MPYSP   .M2X    B5,A4,B4          ; |349| <2,7> 

   [ B0]   SUB     .S2     B0,1,B0           ; <0,16> 
|| [ A2]   SUB     .D1     A2,1,A2           ; <0,16> 
||         XOR     .S1X    A0,B4,A0          ; |348| <1,12> 
||         MPYSP   .M1     A4,A5,A0          ; |348| <2,8> 
||         LDDW    .D2T2   *B6++,B5:B4       ; |348| <4,0> 

;** --------------------------------------------------------------------------*
L9:    ; PIPED LOOP EPILOG
           ADDSP   .L1     A0,A7,A7          ; |348| (E) <4,13>  ^ 
           NOP             1
           ADDSP   .L2     B7,B8,B6          ; |352| 
           NOP             1

           ADD     .D2     4,SP,B4           ; |354| 
||         ADDSP   .L1     A6,A7,A0          ; |351| 

           NOP             3
           STW     .D2T1   A0,*+SP(4)        ; |351| 

           ADD     .S2     8,SP,SP           ; |356| 
||         STW     .D2T2   B6,*+SP(8)        ; |352| 

   [ B1]   LDW     .D2T2   *B4,B4            ; |354| 

           RET     .S2     B3                ; |356| 
|| [ B1]   LDW     .D2T2   *+B4(4),B5        ; |354| 

           NOP             3
   [ B1]   STW     .D2T2   B4,*B1            ; |354| 
   [ B1]   STW     .D2T2   B5,*+B1(4)        ; |354| 
           ; BRANCH OCCURS                   ; |356| 


;**	Parameter deleted: count == 20;
;**	Parameter deleted: p_ImagInput2 == &ImagInput2;
;**	Parameter deleted: p_RealInput2 == &RealInput2;
;**	Parameter deleted: p_ImagInput1 == &ImagInput1;
;**	Parameter deleted: p_RealInput1 == &RealInput1;

	.sect	".text"
	.global	_ComplexDotP3

;******************************************************************************
;* FUNCTION NAME: _ComplexDotP3                                               *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,   *
;*                           A15,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9,B10,B11,B12,   *
;*                           B13,DP,SP                                        *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,   *
;*                           A15,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9,B10,B11,B12,   *
;*                           B13,DP,SP                                        *
;*   Local Frame Size  : 0 Args + 8 Auto + 44 Save = 52 byte                  *
;******************************************************************************
_ComplexDotP3:
;** --------------------------------------------------------------------------*

           MV      .S1X    SP,A0             ; |364| 
||         STW     .D2T1   A15,*SP--(56)     ; |364| 

           STW     .D2T2   B13,*+SP(52)
           STW     .D2T2   B12,*+SP(48)

           STW     .D1T1   A13,*-A0(28)
||         STW     .D2T2   B11,*+SP(44)

           STW     .D1T1   A12,*-A0(32)
||         STW     .D2T2   B10,*+SP(40)

           STW     .D1T1   A14,*-A0(24)
||         STW     .D2T2   B3,*+SP(36)

           MVK     .S2     (_ImagInput2$0-$bss),B4
||         MVK     .S1     (_ImagInput1$0-$bss),A0
||         STW     .D2T1   A11,*+SP(20)

           MVK     .S1     (_RealInput2$0-$bss),A4
||         MVK     .S2     (_RealInput1$0-$bss),B4
||         ADD     .L2     DP,B4,B2
||         ADD     .L1X    DP,A0,A13
||         STW     .D2T1   A10,*+SP(16)

           MV      .L1     A3,A14            ; |364| 
||         ADD     .S1X    DP,A4,A3
||         ADD     .S2     DP,B4,B3
||         LDDW    .D1T1   *A13++,A5:A4      ; |381| (P) <0,0> 
||         LDDW    .D2T2   *B2++,B7:B6       ; |381| (P) <0,0> 

           LDDW    .D2T2   *B3++,B5:B4       ; |381| (P) <0,1> 
||         LDDW    .D1T1   *A3++,A1:A0       ; |381| (P) <0,1> 

           NOP             2
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 377
;*      Loop opening brace source line   : 378
;*      Loop closing brace source line   : 385
;*      Loop Unroll Multiple             : 2x
;*      Known Minimum Trip Count         : 10
;*      Known Maximum Trip Count         : 10
;*      Known Max Trip Count Factor      : 10
;*      Loop Carried Dependency Bound(^) : 4
;*      Unpartitioned Resource Bound     : 4
;*      Partitioned Resource Bound(*)    : 4
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     4*       4*    
;*      .S units                     2        1     
;*      .D units                     2        2     
;*      .M units                     4*       4*    
;*      .X cross paths               4*       4*    
;*      .T address paths             2        2     
;*      Long read paths              0        0     
;*      Long write paths             2        2     
;*      Logical  ops (.LS)           1        1     (.L or .S unit)
;*      Addition ops (.LSD)          1        2     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             4*       3     
;*      Bound(.L .S .D .LS .LSD)     4*       4*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 4  Schedule found with 5 iterations in parallel
;*
;*      Register Usage Table:
;*          +---------------------------------+
;*          |AAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBB|
;*          |0000000000111111|0000000000111111|
;*          |0123456789012345|0123456789012345|
;*          |----------------+----------------|
;*       0: |******** *  **  |* *******  **** |
;*       1: |******** **  *  |* ******  ****  |
;*       2: |******  *    *  |*******   * *   |
;*       3: |* **** *   * *  |* **  ** ** **  |
;*          +---------------------------------+
;*
;*      Done
;*
;*      Epilog not entirely removed
;*      Collapsed epilog stages     : 3
;*
;*      Prolog not entirely removed
;*      Collapsed prolog stages     : 1
;*
;*      Minimum required memory pad : 24 bytes
;*
;*      Minimum safe trip count     : 1 (after unrolling)
;*----------------------------------------------------------------------------*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C177:
;*   0              LDDW    .D2T2   *B2++,B7:B6       ; |381| 
;*       ||         LDDW    .D1T1   *A13++,A5:A4      ; |381| 
;*   1              LDDW    .D1T1   *A3++,A1:A0       ; |381| 
;*       ||         LDDW    .D2T2   *B3++,B5:B4       ; |381| 
;*   2              NOP             3
;*   5              MPYSP   .M2X    B6,A4,B13         ; |381| 
;*       ||         MPYSP   .M1X    B7,A5,A7          ; |381| 
;*   6              MPYSP   .M2X    A0,B4,B11         ; |381| 
;*       ||         MPYSP   .M1     A1,A5,A9          ; |383| 
;*   7              MPYSP   .M1     A0,A4,A5          ; |383| 
;*       ||         MPYSP   .M2     B7,B5,B11         ; |383| 
;*   8              MPYSP   .M2     B6,B4,B12         ; |383| 
;*       ||         MPYSP   .M1X    A1,B5,A4          ; |381| 
;*   9              ZERO    .S1     A12               ; |381| 
;*       ||         ZERO    .S2     DP                ; |381| 
;*  10              ADDSP   .L1X    B11,A6,A6         ; |381|  ^ 
;*       ||         SET     .S1     A12,31,31,A6      ; |381| 
;*       ||         SET     .S2     DP,31,31,B12      ; |381| 
;*  11              XOR     .S2X    B13,A6,B10        ; |381| 
;*       ||         XOR     .S1X    A7,B12,A0         ; |381| 
;*       ||         ADDSP   .L2     B11,B10,B10       ; |383|  ^ 
;*       ||         ADDSP   .L1     A9,A10,A10        ; |383|  ^ 
;*       || [ B0]   SUB     .D2     B0,1,B0           ; |385| 
;*  12              ADDSP   .L2X    A5,B1,B1          ; |383|  ^ 
;*       ||         ADDSP   .L1     A4,A8,A8          ; |381|  ^ 
;*       || [ B0]   B       .S1     C177              ; |385| 
;*  13              ADDSP   .L2     B10,B9,B9         ; |381|  ^ 
;*       ||         ADDSP   .L1     A0,A11,A11        ; |381|  ^ 
;*  14              ADDSP   .L2     B12,B8,B8         ; |383|  ^ 
;*  15              NOP             3
;*                  ; BRANCH OCCURS                   ; |385| 
;*----------------------------------------------------------------------------*
L10:    ; PIPED LOOP PROLOG

           LDDW    .D1T1   *A13++,A5:A4      ; |381| (P) <1,0> 
||         LDDW    .D2T2   *B2++,B7:B6       ; |381| (P) <1,0> 

           MPYSP   .M1X    B7,A5,A7          ; |381| (P) <0,5> 
||         LDDW    .D1T1   *A3++,A1:A0       ; |381| (P) <1,1> 
||         LDDW    .D2T2   *B3++,B5:B4       ; |381| (P) <1,1> 
||         MPYSP   .M2X    B6,A4,B13         ; |381| (P) <0,5> 

           ZERO    .D1     A8                ; |377| 
||         MPYSP   .M1     A1,A5,A9          ; |383| (P) <0,6> 
||         MPYSP   .M2X    A0,B4,B11         ; |381| (P) <0,6> 

           ZERO    .D2     B8                ; |377| 
||         ZERO    .S2     B9                ; |377| 
||         ZERO    .D1     A6                ; |377| 
||         MVK     .S1     0x1,A2            ; init prolog collapse predicate
||         MV      .L1X    DP,A15            ; save dp
||         MPYSP   .M2     B7,B5,B11         ; |383| (P) <0,7> 
||         MPYSP   .M1     A0,A4,A5          ; |383| (P) <0,7> 

           ZERO    .L2     B1                ; |377| 
||         MVK     .S2     9,B0              ; |377| 
||         ZERO    .L1     A11               ; |377| 
||         MPYSP   .M1X    A1,B5,A4          ; |381| (P) <0,8> 
||         B       .S1     L11               ; |385| (P) <0,12> 
||         LDDW    .D2T2   *B2++,B7:B6       ; |381| (P) <2,0> 
||         LDDW    .D1T1   *A13++,A5:A4      ; |381| (P) <2,0> 
||         MPYSP   .M2     B6,B4,B12         ; |383| (P) <0,8> 

           ZERO    .S2     B10               ; |377| 
||         ZERO    .S1     A10               ; |377| 
||         ZERO    .L1     A12               ; |381| (P) <0,9> 
||         ZERO    .L2     DP                ; |381| (P) <0,9> 
||         MPYSP   .M2X    B6,A4,B13         ; |381| (P) <1,5> 
||         LDDW    .D1T1   *A3++,A1:A0       ; |381| (P) <2,1> 
||         LDDW    .D2T2   *B3++,B5:B4       ; |381| (P) <2,1> 
||         MPYSP   .M1X    B7,A5,A7          ; |381| (P) <1,5> 

;** --------------------------------------------------------------------------*
L11:    ; PIPED LOOP KERNEL

   [!A2]   ADDSP   .L2     B12,B8,B8         ; |383| <0,14>  ^ 
||         SET     .S1     A12,31,31,A6      ; |381| <1,10> 
||         SET     .S2     DP,31,31,B12      ; |381| <1,10> 
||         ADDSP   .L1X    B11,A6,A6         ; |381| <1,10>  ^ 
||         MPYSP   .M2X    A0,B4,B11         ; |381| <2,6> 
||         MPYSP   .M1     A1,A5,A9          ; |383| <2,6> 

   [ A2]   SUB     .D1     A2,1,A2           ; <0,15> 
|| [ B0]   SUB     .D2     B0,1,B0           ; |385| <1,11> 
||         ADDSP   .L1     A9,A10,A10        ; |383| <1,11>  ^ 
||         XOR     .S1X    A7,B12,A0         ; |381| <1,11> 
||         XOR     .S2X    B13,A6,B10        ; |381| <1,11> 
||         ADDSP   .L2     B11,B10,B10       ; |383| <1,11>  ^ 
||         MPYSP   .M2     B7,B5,B11         ; |383| <2,7> 
||         MPYSP   .M1     A0,A4,A5          ; |383| <2,7> 

   [ B0]   B       .S1     L11               ; |385| <1,12> 
||         ADDSP   .L2X    A5,B1,B1          ; |383| <1,12>  ^ 
||         ADDSP   .L1     A4,A8,A8          ; |381| <1,12>  ^ 
||         MPYSP   .M2     B6,B4,B12         ; |383| <2,8> 
||         MPYSP   .M1X    A1,B5,A4          ; |381| <2,8> 
||         LDDW    .D2T2   *B2++,B7:B6       ; |381| <4,0> 
||         LDDW    .D1T1   *A13++,A5:A4      ; |381| <4,0> 

           ADDSP   .L1     A0,A11,A11        ; |381| <1,13>  ^ 
||         ADDSP   .L2     B10,B9,B9         ; |381| <1,13>  ^ 
||         ZERO    .S1     A12               ; |381| <2,9> 
||         ZERO    .S2     DP                ; |381| <2,9> 
||         MPYSP   .M1X    B7,A5,A7          ; |381| <3,5> 
||         MPYSP   .M2X    B6,A4,B13         ; |381| <3,5> 
||         LDDW    .D1T1   *A3++,A1:A0       ; |381| <4,1> 
||         LDDW    .D2T2   *B3++,B5:B4       ; |381| <4,1> 

;** --------------------------------------------------------------------------*
L12:    ; PIPED LOOP EPILOG

           MV      .S2X    A15,DP            ; restore dp
||         MV      .S1X    SP,A9             ; |391| 
||         ADDSP   .L2     B12,B8,B8         ; |383| (E) <4,14>  ^ 

           NOP             1
           MV      .S1X    B1,A3
           ADDSP   .L2X    A6,B9,B5          ; |386| 

           MV      .D1     A14,A1            ; |387| 
||         ADD     .D2     4,SP,B4           ; |389| 
||         ADDSP   .L1X    B8,A3,A0          ; |387| 

           NOP             2
           ADDSP   .L2X    A11,B5,B5         ; |386| 
           ADDSP   .L1     A10,A0,A0         ; |387| 
           NOP             2
           ADDSP   .L2X    A8,B5,B7          ; |386| 
           ADDSP   .L1X    B10,A0,A0         ; |387| 
           NOP             2
           STW     .D2T2   B7,*+SP(4)        ; |386| 
           STW     .D2T1   A0,*+SP(8)        ; |387| 
   [ A1]   LDW     .D2T2   *+B4(4),B5        ; |389| 

   [ A1]   MV      .S2X    A14,B4
|| [ A1]   LDW     .D2T2   *B4,B6            ; |389| 

           NOP             3

   [ A1]   MV      .S2X    A14,B4            ; |389| 
|| [ A1]   STW     .D2T2   B5,*+B4(4)        ; |389| 

   [ A1]   STW     .D2T2   B6,*B4            ; |389| 

           LDW     .D1T1   *+A9(32),A14      ; |391| 
||         LDW     .D2T2   *+SP(36),B3       ; |391| 

           LDDW    .D1T1   *+A9(24),A13:A12  ; |391| 
||         LDDW    .D2T2   *+SP(48),B13:B12  ; |391| 

           LDDW    .D1T1   *+A9(16),A11:A10  ; |391| 
||         LDDW    .D2T2   *+SP(40),B11:B10  ; |391| 

           LDW     .D2T1   *++SP(56),A15     ; |391| 
           NOP             1
           RET     .S2     B3                ; |391| 
           NOP             5
           ; BRANCH OCCURS                   ; |391| 


;**	Parameter deleted: y == 3.20000004768371582031F;
;**	Parameter deleted: numBiquad == 10;
;**	Parameter deleted: state == &IIRStatePtr;
;**	Parameter deleted: coefs == &IIRCoeffArray;

	.sect	".text"
	.global	_biquad1

;******************************************************************************
;* FUNCTION NAME: _biquad1                                                    *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,B0,B4,B5,B6,B7                     *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,B0,B3,B4,B5,B6,B7,DP               *
;*   Local Frame Size  : 0 Args + 0 Auto + 0 Save = 0 byte                    *
;******************************************************************************
_biquad1:
;** --------------------------------------------------------------------------*

           MVK     .S1     (_IIRCoeffArray-$bss),A0 ; |399| 
||         MVK     .S2     (_IIRStatePtr-$bss),B4 ; |399| 

           ADD     .D2     DP,B4,B6          ; |399| 
||         ADD     .S1X    DP,A0,A4          ; |399| 

           LDDW    .D1T1   *A4++(16),A1:A0   ; |413| (P) <0,0> 
||         LDDW    .D2T2   *B6,B5:B4         ; |413| (P) <0,0> 

           NOP             3
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 411
;*      Loop opening brace source line   : 412
;*      Loop closing brace source line   : 421
;*      Known Minimum Trip Count         : 10
;*      Known Maximum Trip Count         : 10
;*      Known Max Trip Count Factor      : 10
;*      Loop Carried Dependency Bound(^) : 8
;*      Unpartitioned Resource Bound     : 3
;*      Partitioned Resource Bound(*)    : 4
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     3        1     
;*      .S units                     0        1     
;*      .D units                     2        3     
;*      .M units                     2        2     
;*      .X cross paths               4*       3     
;*      .T address paths             3        2     
;*      Long read paths              1        1     
;*      Long write paths             2        1     
;*      Logical  ops (.LS)           1        0     (.L or .S unit)
;*      Addition ops (.LSD)          0        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             2        1     
;*      Bound(.L .S .D .LS .LSD)     2        2     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 8  Schedule found with 3 iterations in parallel
;*
;*      Register Usage Table:
;*          +---------------------------------+
;*          |AAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBB|
;*          |0000000000111111|0000000000111111|
;*          |0123456789012345|0123456789012345|
;*          |----------------+----------------|
;*       0: |* ***           |*   ***         |
;*       1: |*** **          |*   ****        |
;*       2: |  * **          |*   * **        |
;*       3: |  * *           |*   * *         |
;*       4: |* ***           |*     *         |
;*       5: |******          |*   ****        |
;*       6: |* * **          |*   ****        |
;*       7: |* * *           |*   ***         |
;*          +---------------------------------+
;*
;*      Done
;*
;*      Epilog not entirely removed
;*      Collapsed epilog stages     : 1
;*
;*      Prolog not removed
;*      Collapsed prolog stages     : 0
;*
;*      Minimum required memory pad : 16 bytes
;*
;*      Minimum safe trip count     : 2
;*----------------------------------------------------------------------------*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C226:
;*   0              LDDW    .D2T2   *B6,B5:B4         ; |413| 
;*       ||         LDDW    .D1T1   *A4++(16),A1:A0   ; |413| 
;*   1              NOP             3
;*   4              LDDW    .D1T1   *-A4(8),A1:A0     ; |414| 
;*   5              MPYSP   .M1X    B5,A1,A5          ; |413| 
;*       ||         MPYSP   .M2X    B4,A0,B7          ; |413| 
;*   6              STW     .D2T2   B4,*+B6(4)        ; |416| 
;*   7              NOP             2
;*   9              MPYSP   .M2X    B5,A1,B7          ; |414| 
;*       ||         MPYSP   .M1X    B4,A0,A5          ; |414| 
;*  10              ADDSP   .L1X    B7,A5,A0          ; |413| 
;*  11              NOP             3
;*  14              ADDSP   .L2X    A5,B7,B4          ; |414| 
;*  15              NOP             1
;*  16              ADDSP   .L1     A3,A0,A3          ; |413|  ^ 
;*  17      [ B0]   SUB     .D2     B0,1,B0           ; |421| 
;*  18      [ B0]   B       .S2     C226              ; |421| 
;*  19              MV      .S1X    B4,A0             ; |414| Define a twin register
;*  20              ADDSP   .L1     A3,A0,A3          ; |414|  ^ 
;*  21              STW     .D2T1   A3,*B6++(8)       ; |417| 
;*  22              NOP             2
;*                  ; BRANCH OCCURS                   ; |421| 
;*----------------------------------------------------------------------------*
L13:    ; PIPED LOOP PROLOG
           LDDW    .D1T1   *-A4(8),A1:A0     ; |414| (P) <0,4> 

           MPYSP   .M2X    B4,A0,B7          ; |413| (P) <0,5> 
||         MPYSP   .M1X    B5,A1,A3          ; |413| (P) <0,5> 

           STW     .D2T2   B4,*+B6(4)        ; |416| (P) <0,6> 
           NOP             1

           LDDW    .D1T1   *A4++(16),A1:A0   ; |413| (P) <1,0> 
||         LDDW    .D2T2   *+B6(8),B5:B4     ; |413| (P) <1,0> 

           MPYSP   .M1X    B4,A0,A3          ; |414| (P) <0,9> 
||         MPYSP   .M2X    B5,A1,B7          ; |414| (P) <0,9> 

           ADDSP   .L1X    B7,A3,A0          ; |413| (P) <0,10> 
           NOP             1
           LDDW    .D1T1   *-A4(8),A1:A0     ; |414| (P) <1,4> 

           MVK     .S1     8,A2              ; |411| 
||         MPYSP   .M1X    B5,A1,A5          ; |413| (P) <1,5> 
||         MPYSP   .M2X    B4,A0,B7          ; |413| (P) <1,5> 

           MVKL    .S1     0x404ccccd,A3     ; |399| 
||         ADDSP   .L2X    A3,B7,B4          ; |414| (P) <0,14> 
||         STW     .D2T2   B4,*+B6(12)       ; |416| (P) <1,6> 

           MVK     .S2     9,B0              ; |411| 
||         MVKH    .S1     0x404ccccd,A3     ; |399| 

;** --------------------------------------------------------------------------*
L14:    ; PIPED LOOP KERNEL

           ADDSP   .L1     A3,A0,A3          ; |413| <0,16>  ^ 
||         LDDW    .D2T2   *+B6(16),B5:B4    ; |413| <2,0> 
||         LDDW    .D1T1   *A4++(16),A1:A0   ; |413| <2,0> 

   [ B0]   SUB     .D2     B0,1,B0           ; |421| <0,17> 
||         MPYSP   .M1X    B4,A0,A5          ; |414| <1,9> 
||         MPYSP   .M2X    B5,A1,B7          ; |414| <1,9> 

   [ B0]   B       .S2     L14               ; |421| <0,18> 
||         ADDSP   .L1X    B7,A5,A0          ; |413| <1,10> 

           MV      .S1X    B4,A0             ; |414| <0,19> Define a twin register

           ADDSP   .L1     A3,A0,A3          ; |414| <0,20>  ^ 
||         LDDW    .D1T1   *-A4(8),A1:A0     ; |414| <2,4> 

           STW     .D2T1   A3,*B6++(8)       ; |417| <0,21> 
||         MPYSP   .M2X    B4,A0,B7          ; |413| <2,5> 
||         MPYSP   .M1X    B5,A1,A5          ; |413| <2,5> 

           ADDSP   .L2X    A5,B7,B4          ; |414| <1,14> 
|| [ A2]   STW     .D2T2   B4,*+B6(12)       ; |416| <2,6> 

   [ A2]   SUB     .D1     A2,1,A2           ; <0,23> 
;** --------------------------------------------------------------------------*
L15:    ; PIPED LOOP EPILOG
           ADDSP   .L1     A3,A0,A3          ; |413| (E) <2,16>  ^ 
           NOP             2

           RET     .S2     B3                ; |424| 
||         MV      .S1X    B4,A0             ; |414| (E) <2,19> Define a twin register

           ADDSP   .L1     A3,A0,A0          ; |414| (E) <2,20>  ^ 
           STW     .D2T1   A3,*B6++(8)       ; |417| (E) <2,21> 
           NOP             2
           MV      .D1     A0,A4             ; |423| 
           ; BRANCH OCCURS                   ; |424| 


;**	Parameter deleted: y == 3.20000004768371582031F;
;**	Parameter deleted: numBiquad == 10;
;**	Parameter deleted: state == &IIRStatePtr;
;**	Parameter deleted: coefs == &IIRCoeffArray;

	.sect	".text"
	.global	_biquad2

;******************************************************************************
;* FUNCTION NAME: _biquad2                                                    *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,A7,A9,B0,B1,B2,B3,B4,B5,B6,B7,  *
;*                           B8,B9,B10,SP                                     *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,A7,A9,B0,B1,B2,B3,B4,B5,B6,B7,  *
;*                           B8,B9,B10,DP,SP                                  *
;*   Local Frame Size  : 0 Args + 0 Auto + 4 Save = 4 byte                    *
;******************************************************************************
_biquad2:
;** --------------------------------------------------------------------------*
           MVK     .S2     (_IIRStatePtr-8-$bss),B4

           MVK     .S2     (_IIRCoeffArray-$bss),B5
||         ADD     .D2     DP,B4,B4

           MVK     .S1     0x5,A2            ; init prolog collapse predicate
||         STW     .D2T2   B10,*SP--(8)      ; |433| 
||         ADD     .S2     DP,B5,B8
||         MV      .L1X    B4,A3

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 443
;*      Loop opening brace source line   : 444
;*      Loop closing brace source line   : 454
;*      Known Minimum Trip Count         : 10
;*      Known Maximum Trip Count         : 10
;*      Known Max Trip Count Factor      : 10
;*      Loop Carried Dependency Bound(^) : 4
;*      Unpartitioned Resource Bound     : 3
;*      Partitioned Resource Bound(*)    : 3
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     3*       2     
;*      .S units                     1        0     
;*      .D units                     3*       3*    
;*      .M units                     2        2     
;*      .X cross paths               3*       3*    
;*      .T address paths             3*       3*    
;*      Long read paths              1        1     
;*      Long write paths             0        2     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          0        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             2        1     
;*      Bound(.L .S .D .LS .LSD)     3*       2     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 4  Schedule found with 7 iterations in parallel
;*
;*      Register Usage Table:
;*          +---------------------------------+
;*          |AAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBB|
;*          |0000000000111111|0000000000111111|
;*          |0123456789012345|0123456789012345|
;*          |----------------+----------------|
;*       0: | ******         |***********     |
;*       1: | *******        |** **   ***     |
;*       2: | ******         |****  *****     |
;*       3: |*******         |***********     |
;*          +---------------------------------+
;*
;*      Done
;*
;*      Epilog not entirely removed
;*      Collapsed epilog stages     : 5
;*
;*      Prolog not entirely removed
;*      Collapsed prolog stages     : 5
;*
;*      Minimum required memory pad : 80 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  MV              A3,B9
;*                  ADD             4,B9,B9
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C275:
;*   0              LDW     .D1T1   *++A3(8),A6       ; |445| 
;*       ||         LDDW    .D2T2   *B8++(16),B7:B6   ; |448| 
;*   1              LDW     .D1T1   *+A3(4),A5        ; |446| 
;*       ||         LDDW    .D2T2   *-B8(8),B5:B4     ; |453| 
;*   2              NOP             3
;*   5              MPYSP   .M2X    A6,B6,B2          ; |448| 
;*   6              STW     .D2T1   A6,*++B9(8)       ; |451| 
;*   7              MPYSP   .M2X    A5,B7,B6          ; |448| 
;*       ||         MPYSP   .M1X    A5,B5,A4          ; |453| 
;*   8              MPYSP   .M1X    A6,B4,A7          ; |453| 
;*   9              NOP             2
;*  11              ADDSP   .L2     B2,B6,B10         ; |448| 
;*  12              ADDSP   .L1     A7,A4,A5          ; |453| 
;*  13              NOP             4
;*  17              ADDSP   .L1X    A5,B10,A4         ; |453| 
;*  18              MV      .S2     B10,B3            ; |448| Split a long life
;*  19              NOP             1
;*  20      [ B0]   SUB     .S2     B0,1,B0           ; |454| 
;*  21      [ B0]   B       .S1     C275              ; |454| 
;*  22              ADDSP   .L2X    A0,B3,B6          ; |450| 
;*       ||         ADDSP   .L1     A4,A0,A0          ; |453|  ^ 
;*  23              NOP             3
;*  26              STW     .D1T2   B6,*A3            ; |450| 
;*                  ; BRANCH OCCURS                   ; |454| 
;*----------------------------------------------------------------------------*
L16:    ; PIPED LOOP PROLOG

           MVKL    .S1     0x404ccccd,A0     ; |433| 
||         MVK     .S2     0xa,B5            ; |443| 
||         LDW     .D1T1   *++A3(8),A6       ; |445| (P) <0,0> 
||         LDDW    .D2T2   *B8++(16),B7:B6   ; |448| (P) <0,0> 

           MV      .L1X    B3,A9             ; |433| 
||         ADD     .S2     3,B5,B0
||         LDW     .D1T1   *+A3(4),A5        ; |446| (P) <0,1> 
||         B       .S1     L17               ; |454| (P) <0,21> 
||         LDDW    .D2T2   *-B8(8),B5:B4     ; |453| (P) <0,1> 

           MVK     .S2     0x1000,B1         ; init prolog collapse predicate
||         MVKH    .S1     0x404ccccd,A0     ; |433| 
||         ADD     .D2     4,B4,B9
||         SUB     .L1X    B0,3,A1

;** --------------------------------------------------------------------------*
L17:    ; PIPED LOOP KERNEL

   [ A2]   SUB     .D1     A2,1,A2           ; <0,23> 
||         ADDSP   .L2     B2,B6,B10         ; |448| <3,11> 
||         MPYSP   .M2X    A5,B7,B6          ; |448| <4,7> 
||         MPYSP   .M1X    A5,B5,A4          ; |453| <4,7> 

   [ B0]   SUB     .S2     B0,1,B0           ; |454| <1,20> 
||         ADDSP   .L1     A7,A4,A5          ; |453| <3,12> 
||         MPYSP   .M1X    A6,B4,A7          ; |453| <4,8> 
||         LDDW    .D2T2   *B8++(16),B7:B6   ; |448| <6,0> 
||         LDW     .D1T1   *++A3(8),A6       ; |445| <6,0> 

   [ B0]   B       .S1     L17               ; |454| <1,21> 
||         ADDSP   .L1X    A5,B10,A4         ; |453| <2,17> 
||         MPYSP   .M2X    A6,B6,B2          ; |448| <5,5> 
||         LDDW    .D2T2   *-B8(8),B5:B4     ; |453| <6,1> 
||         LDW     .D1T1   *+A3(4),A5        ; |446| <6,1> 

   [ B1]   MPYSU   .M2     2,B1,B1           ; <0,26> 
|| [ A1]   SUB     .S1     A1,1,A1           ; <0,26> 
|| [!B1]   STW     .D1T2   B6,*-A3(48)       ; |450| <0,26> 
|| [!A2]   ADDSP   .L1     A4,A0,A0          ; |453| <1,22>  ^ 
||         ADDSP   .L2X    A0,B3,B6          ; |450| <1,22> 
||         MV      .S2     B10,B3            ; |448| <2,18> Split a long life
|| [ A1]   STW     .D2T1   A6,*++B9(8)       ; |451| <5,6> 

;** --------------------------------------------------------------------------*
L18:    ; PIPED LOOP EPILOG
           NOP             3

           RET     .S2X    A9                ; |457| 
||         MV      .S1     A0,A4             ; |456| 
||         STW     .D1T2   B6,*-A3(40)       ; |450| (E) <6,26> 

           LDW     .D2T2   *++SP(8),B10      ; |457| 
           NOP             4
           ; BRANCH OCCURS                   ; |457| 



	.sect	".text"
	.global	_main

;******************************************************************************
;* FUNCTION NAME: _main                                                       *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,B0,B1,B2,  *
;*                           B3,B4,B5,B6,B7,B8,B9,B10,B11,B13,SP              *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,B0,B1,B2,  *
;*                           B3,B4,B5,B6,B7,B8,B9,B10,B11,B13,DP,SP           *
;*   Local Frame Size  : 24 Args + 8 Auto + 24 Save = 56 byte                 *
;******************************************************************************
_main:
;** --------------------------------------------------------------------------*
           CALL    .S1     _clock            ; |196| 

           STW     .D2T1   A12,*SP--(56)     ; |188| 
||         MV      .S1X    SP,A9             ; |188| 

           STW     .D2T2   B11,*+SP(52)
           STW     .D2T2   B10,*+SP(48)

           MVKL    .S2     RL0,B3            ; |196| 
||         MV      .L2     B3,B13
||         STW     .D2T2   B13,*+SP(36)
||         STW     .D1T1   A10,*-A9(16)

           MVKH    .S2     RL0,B3            ; |196| 
||         STW     .D1T1   A11,*-A9(12)

RL0:       ; CALL OCCURS                     ; |196| 
           CALL    .S1     _clock            ; |196| 
           MVKL    .S2     RL1,B3            ; |196| 
           MV      .D1     A4,A10            ; |196| 
           MVKH    .S2     RL1,B3            ; |196| 
           NOP             2
RL1:       ; CALL OCCURS                     ; |196| 
           CALL    .S1     _clock            ; |200| 
           MVKL    .S2     RL2,B3            ; |200| 
           MVKH    .S2     RL2,B3            ; |200| 
           SUB     .D1     A4,A10,A10        ; |196| 
           NOP             2
RL2:       ; CALL OCCURS                     ; |200| 
           CALL    .S1     _DotP             ; |202| 
           MVKL    .S2     RL3,B3            ; |202| 
           MV      .L2X    A4,B11            ; |200| 
           MVKH    .S2     RL3,B3            ; |202| 
           NOP             2
RL3:       ; CALL OCCURS                     ; |202| 
           CALL    .S1     _clock            ; |204| 
           MVKL    .S2     RL4,B3            ; |204| 
           MVKH    .S2     RL4,B3            ; |204| 
           NOP             2
           MV      .D1     A4,A11            ; |202| 
RL4:       ; CALL OCCURS                     ; |204| 
           CALL    .S1     _printf           ; |205| 
           MVKL    .S2     SL1+0,B10         ; |205| 
           SUB     .L2X    A4,B11,B4         ; |205| 
           MVKH    .S2     SL1+0,B10         ; |205| 

           SUB     .L2X    B4,A10,B4         ; |205| 
||         STW     .D2T2   B10,*+SP(4)       ; |205| 
||         MVKL    .S2     RL5,B3            ; |205| 

           STW     .D2T2   B4,*+SP(8)        ; |205| 
||         MVKH    .S2     RL5,B3            ; |205| 

RL5:       ; CALL OCCURS                     ; |205| 
           CALL    .S1     _printf           ; |207| 
           MVKL    .S2     SL2+0,B4          ; |207| 

           SPDP    .S1     A11,A1:A0         ; |207| 
||         MVKH    .S2     SL2+0,B4          ; |207| 

           STW     .D2T2   B4,*+SP(4)        ; |207| 

           STW     .D2T1   A0,*+SP(8)        ; |207| 
||         MVKL    .S2     RL6,B3            ; |207| 

           STW     .D2T1   A1,*+SP(12)       ; |207| 
||         MVKH    .S2     RL6,B3            ; |207| 

RL6:       ; CALL OCCURS                     ; |207| 
           CALL    .S1     _clock            ; |210| 
           MVKL    .S2     RL7,B3            ; |210| 
           MVKH    .S2     RL7,B3            ; |210| 
           NOP             3
RL7:       ; CALL OCCURS                     ; |210| 
           CALL    .S1     _ComplexDotP      ; |212| 
           ADD     .D2     SP,28,B4          ; |212| 
           MVKL    .S2     RL8,B3            ; |212| 
           MV      .S1X    B4,A3             ; |212| 
           MVKH    .S2     RL8,B3            ; |212| 
           MV      .D1     A4,A11            ; |210| 
RL8:       ; CALL OCCURS                     ; |212| 
           CALL    .S1     _clock            ; |214| 
           MVKL    .S2     RL9,B3            ; |214| 
           MVKH    .S2     RL9,B3            ; |214| 
           NOP             3
RL9:       ; CALL OCCURS                     ; |214| 
           CALL    .S1     _printf           ; |215| 
           STW     .D2T2   B10,*+SP(4)       ; |215| 
           MVKL    .S2     RL10,B3           ; |215| 
           SUB     .D1     A4,A11,A0         ; |215| 
           SUB     .D1     A0,A10,A0         ; |215| 

           STW     .D2T1   A0,*+SP(8)        ; |215| 
||         MVKH    .S2     RL10,B3           ; |215| 

RL10:      ; CALL OCCURS                     ; |215| 
;** --------------------------------------------------------------------------*
           MVKL    .S1     SL3+0,A0          ; |217| 
           MVKH    .S1     SL3+0,A0          ; |217| 
           STW     .D2T1   A0,*+SP(4)        ; |217| 
           LDW     .D2T2   *+SP(28),B4       ; |217| 
           MVKL    .S2     RL11,B3           ; |217| 
           MVKH    .S2     RL11,B3           ; |217| 
           NOP             2
           SPDP    .S2     B4,B5:B4          ; |217| 
           NOP             1
           STW     .D2T2   B4,*+SP(8)        ; |217| 
           STW     .D2T2   B5,*+SP(12)       ; |217| 
           LDW     .D2T2   *+SP(32),B4       ; |217| 
           NOP             2
           CALL    .S1     _printf           ; |217| 
           NOP             1
           SPDP    .S1X    B4,A1:A0          ; |217| 
           NOP             1
           STW     .D2T1   A0,*+SP(16)       ; |217| 
           STW     .D2T1   A1,*+SP(20)       ; |217| 
RL11:      ; CALL OCCURS                     ; |217| 
           CALL    .S1     _clock            ; |220| 
           MVKL    .S2     RL12,B3           ; |220| 
           MVKH    .S2     RL12,B3           ; |220| 
           NOP             3
RL12:      ; CALL OCCURS                     ; |220| 
           CALL    .S1     _ComplexDotP2     ; |222| 
           ADD     .D2     SP,28,B4          ; |222| 
           MVKL    .S2     RL13,B3           ; |222| 
           MV      .S1X    B4,A3             ; |222| 
           MV      .D1     A4,A11            ; |220| 
           MVKH    .S2     RL13,B3           ; |222| 
RL13:      ; CALL OCCURS                     ; |222| 
           CALL    .S1     _clock            ; |224| 
           MVKL    .S2     RL14,B3           ; |224| 
           MVKH    .S2     RL14,B3           ; |224| 
           NOP             3
RL14:      ; CALL OCCURS                     ; |224| 
           CALL    .S1     _printf           ; |225| 
           STW     .D2T2   B10,*+SP(4)       ; |225| 
           MVKL    .S2     RL15,B3           ; |225| 
           SUB     .D1     A4,A11,A0         ; |225| 
           SUB     .D1     A0,A10,A0         ; |225| 

           STW     .D2T1   A0,*+SP(8)        ; |225| 
||         MVKH    .S2     RL15,B3           ; |225| 

RL15:      ; CALL OCCURS                     ; |225| 
           MVKL    .S2     SL4+0,B4          ; |227| 
           MVKH    .S2     SL4+0,B4          ; |227| 
           STW     .D2T2   B4,*+SP(4)        ; |227| 
           LDW     .D2T2   *+SP(28),B4       ; |227| 
           MVKL    .S2     RL16,B3           ; |227| 
           MVKH    .S2     RL16,B3           ; |227| 
           NOP             2
           SPDP    .S1X    B4,A1:A0          ; |227| 
           NOP             1
           STW     .D2T1   A0,*+SP(8)        ; |227| 
           STW     .D2T1   A1,*+SP(12)       ; |227| 
           LDW     .D2T2   *+SP(32),B4       ; |227| 
           NOP             2
           CALL    .S1     _printf           ; |227| 
           NOP             1
           SPDP    .S2     B4,B5:B4          ; |227| 
           NOP             1
           STW     .D2T2   B4,*+SP(16)       ; |227| 
           STW     .D2T2   B5,*+SP(20)       ; |227| 
RL16:      ; CALL OCCURS                     ; |227| 
           CALL    .S1     _clock            ; |230| 
           MVKL    .S2     RL17,B3           ; |230| 
           MVKH    .S2     RL17,B3           ; |230| 
           NOP             3
RL17:      ; CALL OCCURS                     ; |230| 
           CALL    .S1     _ComplexDotP3     ; |232| 
           MVKL    .S2     RL18,B3           ; |232| 
           ADD     .D2     SP,28,B4          ; |232| 
           MV      .D1     A4,A11            ; |230| 
           MVKH    .S2     RL18,B3           ; |232| 
           MV      .S1X    B4,A3             ; |232| 
RL18:      ; CALL OCCURS                     ; |232| 
           CALL    .S1     _clock            ; |238| 
           MVKL    .S2     RL19,B3           ; |238| 
           MVKH    .S2     RL19,B3           ; |238| 
           NOP             3
RL19:      ; CALL OCCURS                     ; |238| 
           CALL    .S1     _printf           ; |239| 
           STW     .D2T2   B10,*+SP(4)       ; |239| 
           MVKL    .S2     RL20,B3           ; |239| 
           SUB     .D1     A4,A11,A0         ; |239| 
           SUB     .D1     A0,A10,A0         ; |239| 

           STW     .D2T1   A0,*+SP(8)        ; |239| 
||         MVKH    .S2     RL20,B3           ; |239| 

RL20:      ; CALL OCCURS                     ; |239| 
           MVKL    .S1     SL5+0,A0          ; |241| 
           MVKH    .S1     SL5+0,A0          ; |241| 
           STW     .D2T1   A0,*+SP(4)        ; |241| 
           LDW     .D2T2   *+SP(28),B4       ; |241| 
           MVKL    .S2     RL21,B3           ; |241| 
           MVKH    .S2     RL21,B3           ; |241| 
           NOP             2
           SPDP    .S1X    B4,A1:A0          ; |241| 
           NOP             1
           STW     .D2T1   A0,*+SP(8)        ; |241| 
           STW     .D2T1   A1,*+SP(12)       ; |241| 
           LDW     .D2T2   *+SP(32),B4       ; |241| 
           NOP             2
           CALL    .S1     _printf           ; |241| 
           NOP             1
           SPDP    .S2     B4,B5:B4          ; |241| 
           NOP             1
           STW     .D2T2   B4,*+SP(16)       ; |241| 
           STW     .D2T2   B5,*+SP(20)       ; |241| 
RL21:      ; CALL OCCURS                     ; |241| 
;** --------------------------------------------------------------------------*
           MVK     .S2     (_IIRStatePtr-$bss),B4 ; |244| 

           ADD     .D2     DP,B4,B4          ; |244| 
||         ZERO    .S2     B10               ; |244| 

           STW     .D2T2   B10,*+B4(4)       ; |244| 
           STW     .D2T2   B10,*+B4(8)       ; |244| 
           STW     .D2T2   B10,*+B4(12)      ; |244| 
           STW     .D2T2   B10,*+B4(16)      ; |244| 
           STW     .D2T2   B10,*+B4(20)      ; |244| 
           STW     .D2T2   B10,*+B4(24)      ; |244| 
           STW     .D2T2   B10,*+B4(28)      ; |244| 
           STW     .D2T2   B10,*+B4(32)      ; |244| 
           STW     .D2T2   B10,*+B4(36)      ; |244| 
           STW     .D2T2   B10,*+B4(40)      ; |244| 
           STW     .D2T2   B10,*+B4(44)      ; |244| 
           STW     .D2T2   B10,*+B4(48)      ; |244| 
           STW     .D2T2   B10,*+B4(52)      ; |244| 
           STW     .D2T2   B10,*+B4(56)      ; |244| 

           CALL    .S1     _clock            ; |247| 
||         STW     .D2T2   B10,*B4           ; |244| 

           STW     .D2T2   B10,*+B4(60)      ; |244| 
           STW     .D2T2   B10,*+B4(64)      ; |244| 
           STW     .D2T2   B10,*+B4(68)      ; |244| 

           STW     .D2T2   B10,*+B4(72)      ; |244| 
||         MVKL    .S2     RL22,B3           ; |247| 

           STW     .D2T2   B10,*+B4(76)      ; |244| 
||         MVKH    .S2     RL22,B3           ; |247| 

RL22:      ; CALL OCCURS                     ; |247| 

           MV      .D1     A4,A11            ; |247| 
||         MVK     .S1     0x4,A6            ; |249| 

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*      Disqualified loop: Loop contains a call
;*----------------------------------------------------------------------------*
L19:    
           CALL    .S1     _biquad1          ; |250| 
           MVKL    .S2     RL23,B3           ; |250| 
           MVKH    .S2     RL23,B3           ; |250| 
           NOP             3
RL23:      ; CALL OCCURS                     ; |250| 
           SUB     .D1     A6,1,A1           ; |250| 
   [ A1]   B       .S1     L19               ; |250| 
           SUB     .S1     A6,1,A6           ; |250| 
           MV      .D1     A4,A12            ; |250| 
           NOP             3
           ; BRANCH OCCURS                   ; |250| 
;** --------------------------------------------------------------------------*
           CALL    .S1     _clock            ; |252| 
           MVKL    .S2     RL24,B3           ; |252| 
           MVKH    .S2     RL24,B3           ; |252| 
           NOP             3
RL24:      ; CALL OCCURS                     ; |252| 
           CALL    .S1     _printf           ; |253| 
           MVKL    .S1     SL1+0,A0          ; |253| 
           MVKH    .S1     SL1+0,A0          ; |253| 
           SUB     .D1     A4,A11,A3         ; |253| 

           SUB     .D1     A3,A10,A0         ; |253| 
||         MVKL    .S2     RL25,B3           ; |253| 
||         STW     .D2T1   A0,*+SP(4)        ; |253| 

           MVKH    .S2     RL25,B3           ; |253| 
||         STW     .D2T1   A0,*+SP(8)        ; |253| 

RL25:      ; CALL OCCURS                     ; |253| 
           CALL    .S1     _printf           ; |255| 
           MVKL    .S2     SL6+0,B4          ; |255| 

           MVKH    .S2     SL6+0,B4          ; |255| 
||         SPDP    .S1     A12,A1:A0         ; |255| 

           STW     .D2T2   B4,*+SP(4)        ; |255| 

           MVKL    .S2     RL26,B3           ; |255| 
||         STW     .D2T1   A0,*+SP(8)        ; |255| 

           MVKH    .S2     RL26,B3           ; |255| 
||         STW     .D2T1   A1,*+SP(12)       ; |255| 

RL26:      ; CALL OCCURS                     ; |255| 
           MVK     .S2     (_IIRStatePtr-$bss),B4 ; |258| 
           ADD     .D2     DP,B4,B4          ; |258| 
           STW     .D2T2   B10,*+B4(8)       ; |258| 
           STW     .D2T2   B10,*+B4(12)      ; |258| 
           STW     .D2T2   B10,*+B4(16)      ; |258| 
           STW     .D2T2   B10,*+B4(20)      ; |258| 
           STW     .D2T2   B10,*+B4(24)      ; |258| 
           STW     .D2T2   B10,*+B4(28)      ; |258| 
           STW     .D2T2   B10,*+B4(32)      ; |258| 
           STW     .D2T2   B10,*+B4(36)      ; |258| 
           STW     .D2T2   B10,*+B4(40)      ; |258| 
           STW     .D2T2   B10,*+B4(44)      ; |258| 
           STW     .D2T2   B10,*+B4(48)      ; |258| 
           STW     .D2T2   B10,*+B4(52)      ; |258| 
           STW     .D2T2   B10,*+B4(56)      ; |258| 
           STW     .D2T2   B10,*+B4(60)      ; |258| 

           STW     .D2T2   B10,*+B4(4)       ; |258| 
||         CALL    .S1     _clock            ; |261| 

           STW     .D2T2   B10,*+B4(64)      ; |258| 
           STW     .D2T2   B10,*+B4(68)      ; |258| 
           STW     .D2T2   B10,*+B4(72)      ; |258| 

           MVKL    .S2     RL27,B3           ; |261| 
||         STW     .D2T2   B10,*+B4(76)      ; |258| 

           STW     .D2T2   B10,*B4           ; |258| 
||         MVKH    .S2     RL27,B3           ; |261| 

RL27:      ; CALL OCCURS                     ; |261| 

           MV      .D1     A4,A12            ; |261| 
||         MVK     .S1     0x4,A8            ; |263| 

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*      Disqualified loop: Loop contains a call
;*----------------------------------------------------------------------------*
L20:    
           CALL    .S1     _biquad2          ; |264| 
           MVKL    .S2     RL28,B3           ; |264| 
           MVKH    .S2     RL28,B3           ; |264| 
           NOP             3
RL28:      ; CALL OCCURS                     ; |264| 
           SUB     .D1     A8,1,A1           ; |264| 
   [ A1]   B       .S1     L20               ; |264| 
           SUB     .S1     A8,1,A8           ; |264| 
           MV      .D1     A4,A11            ; |264| 
           NOP             3
           ; BRANCH OCCURS                   ; |264| 
;** --------------------------------------------------------------------------*
           CALL    .S1     _clock            ; |266| 
           MVKL    .S2     RL29,B3           ; |266| 
           MVKH    .S2     RL29,B3           ; |266| 
           NOP             3
RL29:      ; CALL OCCURS                     ; |266| 
           CALL    .S1     _printf           ; |267| 
           MVKL    .S1     SL1+0,A3          ; |267| 
           MVKH    .S1     SL1+0,A3          ; |267| 
           SUB     .D1     A4,A12,A0         ; |267| 

           MVKL    .S2     RL30,B3           ; |267| 
||         STW     .D2T1   A3,*+SP(4)        ; |267| 
||         SUB     .D1     A0,A10,A0         ; |267| 

           MVKH    .S2     RL30,B3           ; |267| 
||         STW     .D2T1   A0,*+SP(8)        ; |267| 

RL30:      ; CALL OCCURS                     ; |267| 
           CALL    .S1     _printf           ; |269| 
           MVKL    .S2     SL7+0,B4          ; |269| 

           MVKH    .S2     SL7+0,B4          ; |269| 
||         SPDP    .S1     A11,A1:A0         ; |269| 

           STW     .D2T2   B4,*+SP(4)        ; |269| 

           MVKL    .S2     RL31,B3           ; |269| 
||         STW     .D2T1   A0,*+SP(8)        ; |269| 

           MVKH    .S2     RL31,B3           ; |269| 
||         STW     .D2T1   A1,*+SP(12)       ; |269| 

RL31:      ; CALL OCCURS                     ; |269| 

           LDDW    .D2T2   *+SP(48),B11:B10  ; |271| 
||         MV      .S1X    SP,A9             ; |271| 
||         MV      .S2     B13,B3            ; |271| 

           RET     .S2     B3                ; |271| 
||         LDW     .D2T2   *+SP(36),B13      ; |271| 
||         LDDW    .D1T1   *+A9(40),A11:A10  ; |271| 

           LDW     .D2T1   *++SP(56),A12     ; |271| 
           NOP             4
           ; BRANCH OCCURS                   ; |271| 


;******************************************************************************
;* STRINGS                                                                    *
;******************************************************************************
	.sect	".const"
SL1:	.string	"Benchmark : %d cycles",10,0
SL2:	.string	"Dot product = %f",10,10,0
SL3:	.string	"Complex Dot product #1 = %f + j%f",10,10,0
SL4:	.string	"Complex Dot product #2 = %f + j%f",10,10,0
SL5:	.string	"Complex Dot product #3 = %f + j%f",10,10,0
SL6:	.string	"Biquad 1 result : %f",10,10,0
SL7:	.string	"Biquad 2 result : %f",10,10,0
;******************************************************************************
;* UNDEFINED EXTERNAL REFERENCES                                              *
;******************************************************************************
	.global	_printf
	.global	_clock
